import { GameObject } from "./GameObject";
import { Component } from "./Component";
import { Scene } from "./Scene";
import { Skybox } from "./Skybox";
import { mat4, vec4 } from "./math/GLMath";
export declare enum AmbientType {
    Background = 0,
    AmbientColor = 1
}
export declare enum ClearType {
    Background = 0,
    Skybox = 1
}
export declare enum ProjectionType {
    perspective = 0,
    orthographic = 1
}
export declare class Camera extends Component {
    enabled: boolean;
    order: number;
    private m_fov;
    private m_aspectratio;
    private m_near;
    private m_far;
    private m_projDirty;
    orthosize: number;
    m_projectionType: ProjectionType;
    private m_projMtx;
    private m_worldMtx;
    private m_worldMtxCalculated;
    private m_background;
    private m_ambientColor;
    private m_ambientType;
    private m_clearType;
    private m_skybox;
    private m_dataTrsDirty;
    isDataTrsDirty: boolean;
    private m_dataProjDirty;
    isDataProjDirty: boolean;
    far: number;
    near: number;
    fov: number;
    aspect: number;
    ambientDataDirty: boolean;
    ambientColor: vec4;
    background: vec4;
    skybox: Skybox;
    clearType: ClearType;
    ambientType: AmbientType;
    worldRHS: boolean;
    /** View matrix of camera */
    readonly WorldMatrix: mat4;
    /** Projection matrix of camera */
    readonly ProjMatrix: mat4;
    constructor();
    onUpdate(scene: Scene): void;
    static persepctive(gobj: GameObject, fov: number, aspectratio: number, near: number, far: number): Camera;
    static orthographic(gobj: GameObject, size: number, aspectratio: number, near: number, far: number): Camera;
}
