"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Component_1 = require("./Component");
var Input_1 = require("./Input");
var GLMath_1 = require("./math/GLMath");
var CameraFreeFly = /** @class */ (function (_super) {
    __extends(CameraFreeFly, _super);
    function CameraFreeFly() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.m_startpos = GLMath_1.vec4.zero;
        _this.m_rotay = 0;
        _this.m_rotax = 0;
        return _this;
    }
    CameraFreeFly.prototype.onStart = function () {
        this.m_trs = this.gameobject.transform;
    };
    CameraFreeFly.prototype.onUpdate = function (scene) {
        var trs = this.m_trs;
        var snapshot = Input_1.Input.snapshot;
        if (snapshot.getKey('w')) {
            trs.applyTranslate(trs.worldForward.mulToRef(-0.3), false);
        }
        else if (snapshot.getKey('s')) {
            trs.applyTranslate(trs.worldForward.mulToRef(0.3), false);
        }
        if (snapshot.getKey('d')) {
            trs.applyTranslate(trs.worldRight.mulToRef(-0.3), false);
        }
        else if (snapshot.getKey('a')) {
            trs.applyTranslate(trs.worldRight.mulToRef(0.3), false);
        }
        if (snapshot.mousewheel) {
            var offset = trs.worldForward.mulNumToRef(snapshot.mousewheelDelta * 0.05);
            trs.applyTranslate(offset, false);
        }
        if (snapshot.getMouseBtn(0)) {
            if (snapshot.getMouseDown(0)) {
                this.m_startpos.set(snapshot.mousepos);
                var q = trs.localRotation;
                var e = q.toEuler();
                this.m_rotax = e.x;
                this.m_rotay = e.y;
            }
            else {
                var mpos = snapshot.mousepos;
                var spos = this.m_startpos;
                if (spos.z != 0 || spos.w != 0) {
                    var deltax = mpos.x - spos.x;
                    var deltay = mpos.y - spos.y;
                    if (deltax != 0 && deltay != 0) {
                        var deg2rad = GLMath_1.glmath.Deg2Rad;
                        var rotax = this.m_rotax - deltay * deg2rad * 0.3;
                        var rotay = this.m_rotay + deltax * deg2rad * 0.3;
                        trs.setRotation(GLMath_1.quat.fromEuler(rotax, rotay, 0));
                    }
                }
            }
        }
    };
    return CameraFreeFly;
}(Component_1.Component));
exports.CameraFreeFly = CameraFreeFly;
