"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FRAME_INTERVAL = 60;
var FRAME_INTERVAL_P = FRAME_INTERVAL * 1000;
var FrameTimer = /** @class */ (function () {
    function FrameTimer(printFPS) {
        if (printFPS === void 0) { printFPS = false; }
        this.m_ts = 0;
        this.m_delta = 0;
        this.m_deltaaccu = 0;
        this.m_accuCount = 0;
        this.m_fps = 0;
        this.m_printfps = false;
        this.m_printfps = printFPS;
    }
    Object.defineProperty(FrameTimer.prototype, "fps", {
        get: function () {
            return this.m_fps;
        },
        enumerable: true,
        configurable: true
    });
    FrameTimer.prototype.tick = function (ts) {
        var delta = ts - this.m_ts;
        this.m_delta = delta;
        this.m_ts = ts;
        if (this.m_printfps) {
            this.m_deltaaccu += this.m_delta;
            var accuc = this.m_accuCount;
            accuc++;
            if (accuc >= FRAME_INTERVAL) {
                this.m_fps = FRAME_INTERVAL_P / this.m_deltaaccu;
                this.m_deltaaccu = 0;
                accuc = 0;
                console.log("FPS " + this.m_fps);
            }
            this.m_accuCount = accuc;
        }
        return delta;
    };
    return FrameTimer;
}());
exports.FrameTimer = FrameTimer;
