import { GameObject } from "./GameObject";
import { MeshRender } from "./MeshRender";
import { ShaderFXLibs } from "./shaderfx/ShaderFXLibs";
import { Texture } from "./Texture";
import { GLTFdata } from "./gl/GLTFtool";
import { GLContext } from "./gl/GLContext";
export declare class GLTFSceneBuilder {
    private m_gltfData;
    private m_glctx;
    private m_shaderfxlib;
    private m_pbrShader;
    private m_pbrBlendShader;
    private gltf;
    private buffers;
    private buffersDesc;
    private materials;
    private images;
    constructor(gltfdata: GLTFdata, glctx: GLContext, shaderlib: ShaderFXLibs);
    release(): void;
    createScene(): GameObject;
    private buildNode;
    getMesh(meshid: number): MeshRender;
    private getBuffer;
    private getSize;
    private getMaterial;
    getImage(index: number): Texture;
}
