import { Transform } from "./Transform";
import { Component } from "./Component";
import { Scene } from "./Scene";
import { BaseRender } from "./BaseRender";
export declare class GameObject {
    name: string;
    transform: Transform;
    components: Component[];
    private m_render;
    render: BaseRender;
    addRender<T extends BaseRender>(t: new () => T): T;
    active: boolean;
    constructor(name?: string);
    update(scene: Scene): void;
    addComponent(c: Component): void;
    getComponent<T extends Component>(t: new () => T): Component;
    getChildByName(name: string): GameObject;
}
