import { ShaderFXLibs } from "./shaderfx/ShaderFXLibs";
import { ShadowConfig } from "./render/Shadow";
import { Texture } from "./Texture";
import { IRenderPipeline } from "./pipeline/IRenderPipeline";
import { GLContext } from "./gl/GLContext";
export declare class GraphicsRenderCreateInfo {
    colorFormat: number;
    depthFormat: number;
    frameBufferResizeDelay: number;
}
export declare class GraphicsRender {
    private m_glctx;
    private canvas;
    private m_creationInfo;
    private m_defaultTexture;
    static globalRender: GraphicsRender;
    static readonly TEXID_FB: number;
    static readonly TEXID_TEMP: number;
    static readonly TEXID_DEFAULT_TEX: number;
    static readonly TEXID_SHADER_TEX: number[];
    static readonly TEXID_SHADOW_MAP: number[];
    private m_renderPipeline;
    private m_shaderFXlib;
    shadowConfig: ShadowConfig;
    pause: boolean;
    private m_frameBufferInvalid;
    readonly isFrameBufferInvalid: boolean;
    private m_valid;
    private m_time;
    private m_dt;
    readonly time: number;
    readonly deltaTime: number;
    readonly pipeline: IRenderPipeline;
    readonly shaderLib: ShaderFXLibs;
    readonly glctx: GLContext;
    readonly defaultTexture: Texture;
    constructor(canvas: HTMLCanvasElement, pipeline?: IRenderPipeline, creationInfo?: GraphicsRenderCreateInfo);
    setPipeline(pipeline: IRenderPipeline): void;
    reload(): void;
    release(): void;
    private m_resizeDelayter;
    resizeCanvas(w: number, h: number): void;
    /**
     *
     * @param scene
     * @param dt deltaTime /s
     */
    render(scene: any, dt: number): void;
    renderToCanvas(): void;
}
