import { vec4 } from "./math/GLMath";
import { MapStr } from "./Utility";
export declare class InputSnapShot {
    key: MapStr<boolean>;
    keyDown: {};
    keyUp: {};
    hasKeyPressEvent: boolean;
    mouse: Array<boolean>;
    mouseDown: Array<boolean>;
    mouseUp: Array<boolean>;
    /**
     * [posx,posy,deltax,deltay]
     */
    mousepos: vec4;
    mousewheel: boolean;
    mousewheelDelta: number;
    mouseMove: boolean;
    deltaTime: number;
    getKeyDown(key: string): boolean;
    getKeyUp(key: string): boolean;
    getKey(key: string): boolean;
    getMouseBtn(btn: number): boolean;
    getMouseDown(btn: number): boolean;
    getMouseUp(btn: number): boolean;
}
export declare class Input {
    private static s_inited;
    private static s_canvas;
    private static s_cache;
    static snapshot: InputSnapShot;
    static init(canvas: HTMLCanvasElement): void;
    release(): void;
    private static regEventListener;
    private static removeEventListener;
    private static onEvtKeyDown;
    private static onEvtKeyUp;
    private static onEvtMouseMove;
    private static onEvtMouseDown;
    private static onEvtMouseUp;
    private static onEvtMouseWheel;
    static onFrame(dt: number): void;
}
