import { GameObject } from "./GameObject";
import { vec3 } from "./math/GLMath";
import { Component } from "./Component";
import { Scene } from "./Scene";
export declare enum LightType {
    direction = 0,
    point = 1
}
export declare class Light extends Component {
    lightType: LightType;
    intensity: number;
    lightColor: vec3;
    private m_range;
    private m_paramDirty;
    castShadow: boolean;
    readonly range: number;
    readonly lightPosData: vec3;
    isDirty: boolean;
    private constructor();
    static createPointLight(gobj: GameObject, range?: number, position?: vec3, intensity?: number, color?: vec3): Light;
    static creatDirctionLight(gobj: GameObject, intensity?: number, dir?: vec3, color?: vec3): Light;
    onUpdate(scene: Scene): void;
}
