"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var GLMath_1 = require("./math/GLMath");
var Component_1 = require("./Component");
var LightType;
(function (LightType) {
    LightType[LightType["direction"] = 0] = "direction";
    LightType[LightType["point"] = 1] = "point";
})(LightType = exports.LightType || (exports.LightType = {}));
var Light = /** @class */ (function (_super) {
    __extends(Light, _super);
    function Light(type, intensity, color) {
        var _this = _super.call(this) || this;
        _this.lightType = LightType.point;
        _this.intensity = 1.0;
        _this.lightColor = GLMath_1.vec3.one;
        _this.m_range = 10;
        _this.m_paramDirty = true;
        _this.castShadow = false;
        _this.lightType = type;
        if (intensity)
            _this.intensity = intensity;
        if (color)
            _this.lightColor = color;
        return _this;
    }
    Object.defineProperty(Light.prototype, "range", {
        get: function () {
            return this.m_range;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Light.prototype, "lightPosData", {
        get: function () {
            if (this.lightType == LightType.direction) {
                return this.transform.forward;
            }
            else {
                return this.transform.localPosition;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Light.prototype, "isDirty", {
        get: function () {
            return this.transform.isDirty && this.m_paramDirty;
        },
        set: function (v) {
            if (v) {
                this.m_paramDirty = true;
            }
            else {
                this.m_paramDirty = false;
                this.transform.setLocalDirty(false);
            }
        },
        enumerable: true,
        configurable: true
    });
    Light.createPointLight = function (gobj, range, position, intensity, color) {
        if (range === void 0) { range = 10; }
        var light = new Light(LightType.point, intensity, color);
        gobj.addComponent(light);
        if (position)
            light.transform.localPosition = position;
        light.m_range = range;
        return light;
    };
    Light.creatDirctionLight = function (gobj, intensity, dir, color) {
        if (intensity === void 0) { intensity = 1.0; }
        if (dir === void 0) { dir = GLMath_1.vec3.down; }
        if (color === void 0) { color = GLMath_1.vec3.one; }
        var light = new Light(LightType.direction, intensity, color);
        gobj.addComponent(light);
        light.transform.forward = dir.normalized();
        light.castShadow = true;
        return light;
    };
    Light.prototype.onUpdate = function (scene) {
        scene.addLight(this);
    };
    return Light;
}(Component_1.Component));
exports.Light = Light;
