"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Mesh_1 = require("./Mesh");
var GL_1 = require("./gl/GL");
var MeshBuilder = /** @class */ (function () {
    function MeshBuilder(topology) {
        this.m_indicesCount = 0;
        this.m_topology = topology;
        this.m_positions = [];
        this.m_indiecs = [];
    }
    MeshBuilder.prototype.addLine = function (p0, p1) {
        var pos = this.m_positions;
        pos.push(p0.x, p0.y, p0.z, 1.0, p1.x, p1.y, p1.z, 1.0);
        var indice = this.m_indiecs;
        var indiceCount = this.m_indicesCount;
        indice.push(indiceCount, indiceCount + 1);
        this.m_indicesCount += 2;
    };
    MeshBuilder.prototype.addPoint = function (p) {
    };
    MeshBuilder.prototype.addTri = function (p0, p1, p2) {
        var pos = this.m_positions;
        pos.push(p0.x, p0.y, p0.z, 1.0);
        pos.push(p1.x, p1.y, p1.z, 1.0);
        pos.push(p2.x, p2.y, p2.z, 1.0);
        var index = this.m_indicesCount;
        this.m_indiecs.push(index, index + 1, index + 2);
        this.m_indicesCount = index + 3;
    };
    MeshBuilder.prototype.genMesh = function () {
        var topo = this.m_topology;
        var mesh = new Mesh_1.Mesh();
        mesh.setPosition(new Float32Array(this.m_positions), GL_1.GLConst.FLOAT, 4);
        mesh.setIndices(new Uint16Array(this.m_indiecs), GL_1.GLConst.UNSIGNED_SHORT, topo);
        return mesh;
    };
    return MeshBuilder;
}());
exports.MeshBuilder = MeshBuilder;
