/// <reference types="webgl2" />
import { Mesh } from "./Mesh";
import { Material } from "./Material";
import { GameObject } from "./GameObject";
import { BaseRender } from "./BaseRender";
import { GLContext } from "./gl/GLContext";
import { GLProgram } from "./gl/GLProgram";
export declare class MeshRender extends BaseRender {
    mesh: Mesh;
    object: GameObject;
    _depthVal: number;
    private m_dynamic;
    private m_vao;
    private m_vaoProgamId;
    readonly dynamic: boolean;
    /**
     * @param mesh
     * @param mat
     * @param dynamic dynamic meshRender will not generate VertexArrayObject
     */
    constructor(mesh?: Mesh, mat?: Material, dynamic?: boolean);
    release(glctx: GLContext): void;
    draw(gl: WebGL2RenderingContext): void;
    refreshData(glctx: GLContext): void;
    /**
     * Bind meshbuffers
     * dynamic meshrender: bindBuffer
     * static meshrender: bindVertexArray
     * @param gl
     */
    bindVertexArray(gl: WebGL2RenderingContext): void;
    /**
     * Unbind meshbuffers
     * dynamic meshrender: unbindBuffer
     * static meshrender: unbindVertexArray
     * @param gl
     */
    unbindVertexArray(gl: WebGL2RenderingContext, unbindBuffer?: boolean): void;
    private static bindBuffers;
    static CreateVertexArrayObj(glctx: GLContext, mesh: Mesh, program: GLProgram): WebGLVertexArrayObject;
}
