"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Shader_1 = require("./shaderfx/Shader");
var RenderNodeList = /** @class */ (function () {
    function RenderNodeList() {
        this.nodeOpaque = [];
        this.nodeTransparent = [];
        this.nodeImage = [];
    }
    RenderNodeList.prototype.reset = function () {
        if (this.nodeOpaque.length != 0)
            this.nodeOpaque = [];
        if (this.nodeTransparent.length != 0)
            this.nodeTransparent = [];
        if (this.nodeImage.length != 0)
            this.nodeImage = [];
    };
    RenderNodeList.prototype.pushRenderNode = function (rnode) {
        var material = rnode.material;
        var tag = material.shaderTags;
        if (tag == null)
            return;
        switch (tag.queue) {
            case Shader_1.RenderQueue.Opaque:
                this.nodeOpaque.push(rnode);
                break;
            case Shader_1.RenderQueue.Transparent:
                this.nodeTransparent.push(rnode);
                break;
            case Shader_1.RenderQueue.Image:
                this.nodeImage.push(rnode);
                break;
        }
    };
    RenderNodeList.prototype.sort = function () {
    };
    return RenderNodeList;
}());
exports.RenderNodeList = RenderNodeList;
