import { Texture } from "./Texture";
import { TextureCubeMap } from "./TextureCubeMap";
export declare enum SkyboxType {
    CubeMap = "CUBE",
    Tex360 = "TEX",
    Procedural = "PCG",
    Custom = "CUSTOM"
}
export declare class Skybox {
    private m_rawtex;
    private m_type;
    readonly type: SkyboxType;
    readonly rawTex: Texture;
    protected constructor(type: SkyboxType);
    static createFromCubeMap(cubemap: TextureCubeMap): Skybox;
    static createFromTex360(tex: Texture): Skybox;
    static createFromProcedural(): Skybox;
}
