"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var SkyboxType;
(function (SkyboxType) {
    SkyboxType["CubeMap"] = "CUBE";
    SkyboxType["Tex360"] = "TEX";
    SkyboxType["Procedural"] = "PCG";
    SkyboxType["Custom"] = "CUSTOM";
})(SkyboxType = exports.SkyboxType || (exports.SkyboxType = {}));
var Skybox = /** @class */ (function () {
    function Skybox(type) {
        this.m_type = type;
    }
    Object.defineProperty(Skybox.prototype, "type", {
        get: function () { return this.m_type; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Skybox.prototype, "rawTex", {
        get: function () { return this.m_rawtex; },
        enumerable: true,
        configurable: true
    });
    Skybox.createFromCubeMap = function (cubemap) {
        if (cubemap == null)
            return null;
        var sb = new Skybox(SkyboxType.CubeMap);
        sb.m_rawtex = cubemap;
        return sb;
    };
    Skybox.createFromTex360 = function (tex) {
        if (tex == null)
            return null;
        var sb = new Skybox(SkyboxType.Tex360);
        sb.m_rawtex = tex;
        return sb;
    };
    Skybox.createFromProcedural = function () {
        var sb = new Skybox(SkyboxType.Procedural);
        return sb;
    };
    return Skybox;
}());
exports.Skybox = Skybox;
