"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var MeshRender_1 = require("./MeshRender");
var Mesh_1 = require("./Mesh");
var Material_1 = require("./Material");
var GraphicsRender_1 = require("./GraphicsRender");
var ShaderFX_1 = require("./shaderfx/ShaderFX");
var GLMath_1 = require("./math/GLMath");
var SpriteRender = /** @class */ (function (_super) {
    __extends(SpriteRender, _super);
    function SpriteRender() {
        var _this = _super.call(this) || this;
        _this.m_imageDirty = false;
        _this.m_color = GLMath_1.vec4.one;
        _this.m_colorDirty = true;
        _this.mesh = Mesh_1.Mesh.Quad;
        _this.material = new Material_1.Material(GraphicsRender_1.GraphicsRender.globalRender.shaderLib.shaderSprite);
        return _this;
    }
    Object.defineProperty(SpriteRender.prototype, "image", {
        get: function () { return this.m_image; },
        set: function (t) {
            if (t == this.m_image)
                return;
            this.m_image = t;
            this.m_imageDirty = true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SpriteRender.prototype, "color", {
        get: function () { return this.m_color; },
        set: function (c) { this.m_color.set(c); this.m_colorDirty = true; },
        enumerable: true,
        configurable: true
    });
    SpriteRender.prototype.refreshData = function (glctx) {
        _super.prototype.refreshData.call(this, glctx);
        if (this.m_imageDirty) {
            this.material.setTexture(ShaderFX_1.ShaderFX.UNIFORM_MAIN_TEXTURE, this.m_image);
            this.m_imageDirty = false;
        }
        if (this.m_colorDirty) {
            this.m_colorDirty = false;
            this.material.setColor(ShaderFX_1.ShaderFX.UNIFORM_MAIN_COLOR, this.m_color);
        }
    };
    return SpriteRender;
}(MeshRender_1.MeshRender));
exports.SpriteRender = SpriteRender;
