import { GLContext } from "./gl/GLContext";
export declare class TextureCreationDesc {
    format: number;
    internalformat: number;
    mipmap: boolean;
    min_filter: number;
    mag_filter: number;
    wrap_s: number;
    wrap_t: number;
    constructor(fmt: number, internalfmt: number, mipmap?: boolean, min_filter?: number, mag_filter?: number, wrap_s?: number, wrap_t?: number);
    clone(): any;
}
export declare class Texture {
    static TEMP_TEXID: number;
    protected m_raw: WebGLTexture;
    protected m_width: number;
    protected m_height: number;
    protected m_desc: TextureCreationDesc;
    readonly rawtexture: WebGLTexture;
    readonly width: number;
    readonly height: number;
    constructor(tex?: WebGLTexture, width?: number, heigt?: number, desc?: TextureCreationDesc);
    release(glctx: GLContext): void;
    static createTexture2D(width: number, height: number, desc: TextureCreationDesc, glctx: GLContext): Texture;
    static loadTexture2D(url: string, glctx: GLContext, alpha?: boolean): Promise<Texture>;
    resize(width: number, height: number, glctx: GLContext): void;
    static crateEmptyTexture(width: number, height: number, glctx: GLContext): Texture;
    static createTextureSync(buffer: Uint8Array, mime: string, glctx: GLContext, callback?: (suc: boolean) => void): Texture;
    static createTexture(buffer: Uint8Array, mime: string, glctx: GLContext): Promise<Texture>;
}
