"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var GL_1 = require("./gl/GL");
var ShaderFX_1 = require("./shaderfx/ShaderFX");
var TextureCreationDesc = /** @class */ (function () {
    function TextureCreationDesc(fmt, internalfmt, mipmap, min_filter, mag_filter, wrap_s, wrap_t) {
        if (mipmap === void 0) { mipmap = false; }
        if (min_filter === void 0) { min_filter = GL_1.GL.LINEAR; }
        if (mag_filter === void 0) { mag_filter = GL_1.GL.LINEAR; }
        if (wrap_s === void 0) { wrap_s = GL_1.GL.CLAMP_TO_EDGE; }
        if (wrap_t === void 0) { wrap_t = GL_1.GL.CLAMP_TO_EDGE; }
        this.mipmap = false;
        this.format = fmt;
        this.internalformat = internalfmt;
        this.mipmap = mipmap;
        this.min_filter = min_filter;
        this.mag_filter = mag_filter;
        this.wrap_s = wrap_s;
        this.wrap_t = wrap_t;
    }
    TextureCreationDesc.prototype.clone = function () {
        var c = Object.create(TextureCreationDesc.prototype);
        for (var p in this) {
            c[p] = this[p];
        }
        return c;
    };
    return TextureCreationDesc;
}());
exports.TextureCreationDesc = TextureCreationDesc;
var Texture = /** @class */ (function () {
    function Texture(tex, width, heigt, desc) {
        if (width === void 0) { width = 0; }
        if (heigt === void 0) { heigt = 0; }
        this.m_raw = tex;
        this.m_width = width;
        this.m_height = heigt;
        this.m_desc = desc == null ? null : desc.clone();
    }
    Object.defineProperty(Texture.prototype, "rawtexture", {
        get: function () {
            return this.m_raw;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Texture.prototype, "width", {
        get: function () { return this.m_width; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Texture.prototype, "height", {
        get: function () { return this.m_height; },
        enumerable: true,
        configurable: true
    });
    Texture.prototype.release = function (glctx) {
        if (this.m_raw) {
            glctx.gl.deleteTexture(this.m_raw);
            this.m_raw = null;
        }
        return;
    };
    Texture.createTexture2D = function (width, height, desc, glctx) {
        var gl = glctx.gl;
        var tex = gl.createTexture();
        gl.activeTexture(ShaderFX_1.ShaderFX.GL_TEXTURE_TEMP);
        gl.bindTexture(gl.TEXTURE_2D, tex);
        gl.texStorage2D(gl.TEXTURE_2D, 1, desc.internalformat, width, height);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, desc.mag_filter);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, desc.min_filter);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, desc.wrap_s);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, desc.wrap_t);
        if (desc.mipmap) {
            gl.generateMipmap(gl.TEXTURE_2D);
        }
        gl.bindTexture(gl.TEXTURE_2D, null);
        var texture = new Texture(tex, width, height, desc);
        return texture;
    };
    Texture.loadTexture2D = function (url, glctx, alpha) {
        if (alpha === void 0) { alpha = true; }
        return new Promise(function (res, rej) {
            var img = new Image();
            var gl = glctx.gl;
            img.onload = function () {
                var tex = gl.createTexture();
                try {
                    var desc = new TextureCreationDesc(alpha ? gl.RGBA : gl.RGB, alpha ? gl.RGBA : gl.RGB, false, gl.LINEAR, gl.LINEAR);
                    gl.bindTexture(gl.TEXTURE_2D, tex);
                    gl.texImage2D(gl.TEXTURE_2D, 0, desc.format, desc.internalformat, gl.UNSIGNED_BYTE, img);
                    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, desc.mag_filter);
                    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, desc.min_filter);
                    gl.generateMipmap(gl.TEXTURE_2D);
                    gl.bindTexture(gl.TEXTURE_2D, null);
                    res(new Texture(tex, img.width, img.height, desc));
                }
                catch (e) {
                    gl.deleteTexture(tex);
                    rej(e);
                }
            };
            img.onerror = function (ev) {
                rej(ev);
            };
            img.src = url;
        });
    };
    Texture.prototype.resize = function (width, height, glctx) {
        if (width == this.m_width && height == this.m_height)
            return;
        var gl = glctx.gl;
        gl.deleteTexture(this.m_raw);
        var desc = this.m_desc;
        var tex = gl.createTexture();
        gl.activeTexture(ShaderFX_1.ShaderFX.GL_TEXTURE_TEMP);
        gl.bindTexture(gl.TEXTURE_2D, tex);
        gl.texStorage2D(gl.TEXTURE_2D, 1, desc.internalformat, width, height);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, desc.mag_filter);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, desc.min_filter);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, desc.wrap_s);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, desc.wrap_t);
        if (desc.mipmap) {
            gl.generateMipmap(gl.TEXTURE_2D);
        }
        gl.bindTexture(gl.TEXTURE_2D, null);
        this.m_raw = tex;
        this.m_width = width;
        this.m_height = height;
    };
    Texture.crateEmptyTexture = function (width, height, glctx) {
        if (width < 2 || height < 2) {
            throw new Error('invalid texture size');
        }
        var gl = glctx.gl;
        var tex = gl.createTexture();
        gl.activeTexture(Texture.TEMP_TEXID);
        gl.bindTexture(gl.TEXTURE_2D, tex);
        gl.texStorage2D(gl.TEXTURE_2D, 1, gl.RGBA8, width, height);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
        gl.bindTexture(gl.TEXTURE_2D, null);
        return new Texture(tex, width, height);
    };
    Texture.createTextureSync = function (buffer, mime, glctx, callback) {
        var blob = new Blob([buffer], { type: mime });
        var url = URL.createObjectURL(blob);
        var image = new Image();
        var tex = new Texture(null);
        image.onload = function () {
            var gl = glctx.gl;
            var rawtex = gl.createTexture();
            gl.activeTexture(Texture.TEMP_TEXID);
            gl.bindTexture(gl.TEXTURE_2D, rawtex);
            gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGB, gl.RGB, gl.UNSIGNED_BYTE, image);
            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
            gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
            gl.generateMipmap(gl.TEXTURE_2D);
            gl.bindTexture(gl.TEXTURE_2D, null);
            tex.m_width = image.width;
            tex.m_height = image.height;
            tex.m_raw = rawtex;
            if (callback != null)
                callback(true);
        };
        image.onerror = function (ev) {
            console.error(ev);
            if (callback != null)
                callback(false);
        };
        image.src = url;
        return tex;
    };
    Texture.createTexture = function (buffer, mime, glctx) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (res, rej) {
                        var tex = Texture.createTextureSync(buffer, mime, glctx, function (suc) {
                            if (suc) {
                                res(tex);
                            }
                            else {
                                rej('failed');
                            }
                        });
                    })];
            });
        });
    };
    return Texture;
}());
exports.Texture = Texture;
