import { Texture, TextureCreationDesc } from './Texture';
import { GLContext } from './gl/GLContext';
/**
 * TEXTURE_CUBE_MAP wrapped by Texture
 */
export declare class TextureCubeMap extends Texture {
    readonly gltex: WebGLTexture;
    constructor(tex?: WebGLTexture, width?: number, height?: number, desc?: TextureCreationDesc);
    /**
     * create cubemap texture with six-faces images
     * @param urls [Front,Back,Up,Down,Right,Left]
     * @param glctx
     */
    static loadCubeMap(urls: string[], glctx: GLContext): Promise<TextureCubeMap>;
}
