import { vec3, mat4, quat } from "./math/GLMath";
/**
 * WIP efactoring
 * substitution of class Transform.
 */
export declare class Trans {
    private m_localPosition;
    private m_localRotation;
    private m_localScale;
    private m_localMtx;
    private m_localMtxDirty;
    private m_locaLTRSDirty;
    private m_worldpos;
    private m_worldRotation;
    private m_worldScale;
    private m_worldMtx;
    private m_worldMtxInv;
    /**
     * mark for any values changed of world.TRS
     */
    private m_worldMtxDirty;
    /**
     * This mark set to true when worldPosition changed.
     * For setting local/world position, accessing worldPosition should not invoke @function <updateWorldMatrix> .
     */
    private m_worldPosDirty;
    private m_worldScaleDirty;
    private m_worldRotaDirty;
    private m_up;
    private m_right;
    private m_forward;
    readonly up: vec3;
    readonly right: vec3;
    readonly forward: vec3;
    private m_children;
    private m_parent;
    private m_gameobj;
    readonly localMtx: mat4;
    readonly localPosition: vec3;
    readonly localRoataion: quat;
    readonly localScale: vec3;
    readonly worldPosition: vec3;
    readonly worldRotation: quat;
    readonly worldScale: vec3;
    readonly worldMtx: mat4;
    readonly objectToWorldMatrix: mat4;
    readonly parentWorldMtx: mat4;
    parent: Trans;
    readonly children: Trans[];
    /**
     * set position default is world-space
     * @param pos
     * @param worldspace @default true
     */
    setPosition(pos: vec3, worldspace?: boolean): void;
    /** set local scale */
    setScale(scale: vec3): void;
    /**
     * set rotation, world-space is default
     * @param q
     * @param worldspace @default true
     */
    setRotation(q: quat, worldspace?: boolean): void;
    private updateLocalMtx;
    private updateWorldMtx;
    updateWorldMatrix(pwmtxDirty: boolean): void;
    removeChild(trs: Trans): boolean;
    addChild(trs: Trans): boolean;
}
