import { vec4 } from "./math/GLMath";
export declare type MapStr<T> = {
    [key: string]: T;
};
export declare type MapNum<T> = {
    [key: number]: T;
};
export declare class Delayter {
    private m_newEmit;
    private m_ondelay;
    private m_f;
    private m_time;
    constructor(time?: number);
    delaytime: number;
    emit(f: () => void): void;
    private delayExec;
}
export declare class Utility {
    /**
     * Simple hash function
     * @param str
     */
    static Hashfnv32a(str: string): number;
    /**
     * Deep clone map object
     * @param map
     */
    static cloneMap<T, U extends MapStr<T> | MapNum<T>>(map: U, itemclone?: (t: any) => any): U;
    static randomColor(): vec4;
    static colorRGBA(r: number, g: number, b: number, a: number): vec4;
    static byteDataToImageData(width: number, height: number, data: Uint8Array): string;
    static byteDataToImage(width: number, height: number, data: Uint8Array, cb: (img: HTMLImageElement) => void): void;
}
export declare class WindowUtility {
    private static onResizeFunc;
    private static s_windowResizeRegisted;
    static setOnResizeFunc(callback: () => void): void;
    private static onWindowResize;
}
