"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var GLMath_1 = require("./math/GLMath");
var Delayter = /** @class */ (function () {
    function Delayter(time) {
        if (time === void 0) { time = 300; }
        this.m_newEmit = false;
        this.m_ondelay = false;
        this.m_time = 300;
        this.m_time;
    }
    Object.defineProperty(Delayter.prototype, "delaytime", {
        set: function (t) {
            this.m_time = t;
        },
        enumerable: true,
        configurable: true
    });
    Delayter.prototype.emit = function (f) {
        if (f == null)
            return;
        this.m_f = f;
        if (this.m_ondelay == true) {
            this.m_newEmit = true;
        }
        else {
            this.m_newEmit = false;
            this.m_ondelay = true;
            this.delayExec();
        }
    };
    Delayter.prototype.delayExec = function () {
        var self = this;
        setTimeout(function () {
            if (self.m_newEmit) {
                self.m_newEmit = false;
                self.delayExec();
            }
            else {
                self.m_f();
                self.m_ondelay = false;
            }
        }, this.m_time);
    };
    return Delayter;
}());
exports.Delayter = Delayter;
var Utility = /** @class */ (function () {
    function Utility() {
    }
    /**
     * Simple hash function
     * @param str
     */
    Utility.Hashfnv32a = function (str) {
        var FNV1_32A_INIT = 0x811c9dc5;
        var hval = FNV1_32A_INIT;
        for (var i = 0; i < str.length; ++i) {
            hval ^= str.charCodeAt(i);
            hval += (hval << 1) + (hval << 4) + (hval << 7) + (hval << 8) + (hval << 24);
        }
        return hval >>> 0;
    };
    /**
     * Deep clone map object
     * @param map
     */
    Utility.cloneMap = function (map, itemclone) {
        if (map == null)
            return null;
        var ret = {};
        if (itemclone) {
            for (var key in map) {
                var val = map[key];
                ret[key] = itemclone(val);
            }
        }
        else {
            for (var key in map) {
                ret[key] = map[key];
            }
        }
        return ret;
    };
    Utility.randomColor = function () {
        return GLMath_1.glmath.vec4(Math.random(), Math.random(), Math.random(), 1);
    };
    Utility.colorRGBA = function (r, g, b, a) {
        return GLMath_1.glmath.vec4(r, g, b, a).div(255.0);
    };
    Utility.byteDataToImageData = function (width, height, data) {
        var tempcanvas = document.createElement('canvas');
        tempcanvas.width = width;
        tempcanvas.height = height;
        var ctx2d = tempcanvas.getContext('2d');
        var imgdata = ctx2d.createImageData(width, height);
        imgdata.data.set(data);
        ctx2d.putImageData(imgdata, 0, 0);
        return tempcanvas.toDataURL();
    };
    Utility.byteDataToImage = function (width, height, data, cb) {
        var src = Utility.byteDataToImageData(width, height, data);
        var img = new Image();
        img.onload = function () {
            cb(img);
        };
        img.onerror = function () {
            cb(null);
        };
        img.src = src;
    };
    return Utility;
}());
exports.Utility = Utility;
var WindowUtility = /** @class */ (function () {
    function WindowUtility() {
    }
    WindowUtility.setOnResizeFunc = function (callback) {
        WindowUtility.onResizeFunc = callback;
        if (this.s_windowResizeRegisted) {
            return;
        }
        WindowUtility.s_windowResizeRegisted = true;
        window.addEventListener('resize', WindowUtility.onWindowResize);
    };
    WindowUtility.onWindowResize = function () {
        var cb = WindowUtility.onResizeFunc;
        if (cb != null) {
            cb();
        }
    };
    WindowUtility.s_windowResizeRegisted = false;
    return WindowUtility;
}());
exports.WindowUtility = WindowUtility;
