"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var GLProgram = /** @class */ (function () {
    function GLProgram(gl, program) {
        this.Attributes = {};
        this.Uniforms = {};
        this.UniformsInfo = {};
        this.UniformBlock = {};
        this.Program = program;
        var numAttrs = gl.getProgramParameter(program, gl.ACTIVE_ATTRIBUTES);
        for (var i = 0; i < numAttrs; i++) {
            var attrInfo = gl.getActiveAttrib(program, i);
            if (attrInfo == null)
                continue;
            var attrLoca = gl.getAttribLocation(program, attrInfo.name);
            this.Attributes[attrInfo.name] = attrLoca;
        }
        var numUniform = gl.getProgramParameter(program, gl.ACTIVE_UNIFORMS);
        for (var i = 0; i < numUniform; i++) {
            var uniformInfo = gl.getActiveUniform(program, i);
            if (uniformInfo == null)
                continue;
            var uname = uniformInfo.name;
            this.UniformsInfo[uname] = uniformInfo;
            var uniformLoca = gl.getUniformLocation(program, uname);
            this.Uniforms[uname] = uniformLoca;
        }
        var numublock = gl.getProgramParameter(program, gl.ACTIVE_UNIFORM_BLOCKS);
        for (var i = 0; i < numublock; i++) {
            var ublockName = gl.getActiveUniformBlockName(program, i);
            if (ublockName != null) {
                this.UniformBlock[ublockName] = i;
            }
        }
    }
    Object.defineProperty(GLProgram.prototype, "id", {
        get: function () {
            if (this.m_id == null) {
                GLProgram.s_id++;
                this.m_id = GLProgram.s_id;
            }
            return this.m_id;
        },
        enumerable: true,
        configurable: true
    });
    GLProgram.prototype.GetUniform = function (key) {
        return this.Uniforms[key];
    };
    GLProgram.prototype.GetAttribute = function (key) {
        return this.Attributes[key];
    };
    GLProgram.s_id = 0;
    return GLProgram;
}());
exports.GLProgram = GLProgram;
