/// <reference types="webgl2" />
import { Texture } from "../Texture";
declare type OnFrameFunc = (t: number) => void;
export declare class GLUtility {
    private static s_animationFrameRegisted;
    private static s_animationFrameFunc;
    static registerOnFrame(f: OnFrameFunc): void;
    static removeOnFrame(f: OnFrameFunc): void;
    private static s_lastTime;
    private static s_targetFPS;
    private static s_frameInterval;
    static setTargetFPS(fps: number): void;
    private static onAnimationFrame;
    static HttpGet(url: string, type: XMLHttpRequestResponseType): Promise<any>;
    static loadImage(url: string): Promise<HTMLImageElement>;
    static saveTextureToImage(gl: WebGL2RenderingContext, texture: Texture, tempframebfufer: WebGLFramebuffer): HTMLImageElement;
    static saveFrameBufferToImageData(width: number, height: number, gl: WebGL2RenderingContext, targetframebuffer: WebGLFramebuffer): string;
    static saveFrameBufferToImage(width: number, height: number, gl: WebGL2RenderingContext, targetframebuffer: WebGLFramebuffer): HTMLImageElement;
}
export {};
