"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var GLUtility = /** @class */ (function () {
    function GLUtility() {
    }
    GLUtility.registerOnFrame = function (f) {
        if (!GLUtility.s_animationFrameRegisted) {
            window.requestAnimationFrame(GLUtility.onAnimationFrame);
            GLUtility.s_animationFrameRegisted = true;
        }
        GLUtility.s_animationFrameFunc.push(f);
    };
    GLUtility.removeOnFrame = function (f) {
        var func = GLUtility.s_animationFrameFunc;
        var index = func.indexOf(f);
        if (index >= 0) {
            GLUtility.s_animationFrameFunc = func.splice(index, 1);
        }
    };
    GLUtility.setTargetFPS = function (fps) {
        GLUtility.s_targetFPS = fps;
        GLUtility.s_frameInterval = 1000.0 / fps;
    };
    GLUtility.onAnimationFrame = function (t) {
        var interval = GLUtility.s_frameInterval;
        var elapsed = t - GLUtility.s_lastTime;
        if (elapsed >= interval) {
            GLUtility.s_lastTime = t - elapsed % interval;
            var func = GLUtility.s_animationFrameFunc;
            for (var i = 0, len = func.length; i < len; i++) {
                func[i](t);
            }
        }
        window.requestAnimationFrame(GLUtility.onAnimationFrame);
    };
    GLUtility.HttpGet = function (url, type) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (res, rej) {
                        var xhr = new XMLHttpRequest();
                        xhr.responseType = type;
                        xhr.onload = function (evt) {
                            if (type == "blob" || type == "arraybuffer") {
                                res(xhr.response);
                            }
                            else {
                                res(xhr.responseText);
                            }
                        };
                        xhr.onerror = function (evt) {
                            rej(evt.target);
                        };
                        xhr.open("GET", url, true);
                        xhr.send();
                    })];
            });
        });
    };
    GLUtility.loadImage = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (url == null)
                    return [2 /*return*/, null];
                return [2 /*return*/, new Promise(function (res, rej) {
                        var img = new Image();
                        img.onload = function () {
                            res(img);
                        };
                        img.onerror = function () {
                            rej('image load failed');
                        };
                        img.src = url;
                    })];
            });
        });
    };
    GLUtility.saveTextureToImage = function (gl, texture, tempframebfufer) {
        if (texture == null || tempframebfufer == null)
            return null;
        var curfb = gl.getParameter(gl.FRAMEBUFFER_BINDING);
        var curtex = gl.getParameter(gl.TEXTURE_BINDING_2D);
        gl.bindFramebuffer(gl.FRAMEBUFFER, tempframebfufer);
        var rawtex = texture.rawtexture;
        gl.bindTexture(gl.TEXTURE_2D, rawtex);
        gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, rawtex, 0);
        var image = GLUtility.saveFrameBufferToImage(texture.width, texture.height, gl, tempframebfufer);
        gl.bindTexture(gl.TEXTURE_2D, curtex);
        gl.bindFramebuffer(gl.FRAMEBUFFER, curfb);
        return image;
    };
    GLUtility.saveFrameBufferToImageData = function (width, height, gl, targetframebuffer) {
        var w = width;
        var h = height;
        var data = new Uint8Array(w * h * 4);
        gl.readPixels(0, 0, w, h, gl.RGBA, gl.UNSIGNED_BYTE, data);
        var tempcanvas = document.createElement('canvas');
        tempcanvas.width = w;
        tempcanvas.height = h;
        var ctx2d = tempcanvas.getContext('2d');
        var imgdata = ctx2d.createImageData(w, h);
        imgdata.data.set(data);
        ctx2d.putImageData(imgdata, 0, 0);
        return tempcanvas.toDataURL();
    };
    GLUtility.saveFrameBufferToImage = function (width, height, gl, targetframebuffer) {
        var image = new Image();
        image.src = GLUtility.saveFrameBufferToImageData(width, height, gl, targetframebuffer);
        return image;
    };
    GLUtility.s_animationFrameRegisted = false;
    GLUtility.s_animationFrameFunc = [];
    GLUtility.s_lastTime = 0;
    GLUtility.s_targetFPS = 60;
    GLUtility.s_frameInterval = 1000 / 60.0;
    return GLUtility;
}());
exports.GLUtility = GLUtility;
