"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var PipelineBase_1 = require("../pipeline/PipelineBase");
var Shader_1 = require("../shaderfx/Shader");
var Material_1 = require("../Material");
var Mesh_1 = require("../Mesh");
var GLMath_1 = require("../math/GLMath");
var MeshRender_1 = require("../MeshRender");
var ShaderFX_1 = require("../shaderfx/ShaderFX");
var MeshBuilder_1 = require("../MeshBuilder");
var RenderPass_1 = require("./RenderPass");
var PassGizmos = /** @class */ (function (_super) {
    __extends(PassGizmos, _super);
    function PassGizmos(pipe) {
        var _this = _super.call(this, pipe) || this;
        _this.enable = true;
        if (PassGizmos.s_shader == null) {
            var shader = ShaderFX_1.ShaderFX.compileShaders(pipe.GLCtx, PassGizmos.SH_gizmos);
            PassGizmos.s_shader = shader;
        }
        var mat = new Material_1.Material(PassGizmos.s_shader);
        _this.m_material = mat;
        var mesh = _this.genMesh();
        _this.m_mesh = mesh;
        if (mesh != null) {
            _this.m_vao = MeshRender_1.MeshRender.CreateVertexArrayObj(pipe.GLCtx, mesh, mat.program);
        }
        var tags = new Shader_1.ShaderTags();
        tags.blend = false;
        tags.ztest = Shader_1.Comparison.LEQUAL;
        tags.zwrite = false;
        tags.fillDefaultVal();
        _this.m_tags = tags;
        return _this;
    }
    PassGizmos.prototype.render = function (scene) {
        if (!this.enable)
            return;
        var mesh = this.m_mesh;
        if (mesh == null)
            return;
        var CLASS = PipelineBase_1.PipelineBase;
        var NAME_BASIS = ShaderFX_1.ShaderFX.UNIFORM_BASIS;
        var NAME_OBJ = ShaderFX_1.ShaderFX.UNIFORM_OBJ;
        var pipeline = this.pipeline;
        var gl = pipeline.GL;
        pipeline.stateCache.apply(this.m_tags);
        var mat = this.m_material;
        var program = mat.program;
        var glp = program.Program;
        gl.useProgram(program.Program);
        var ublock = program.UniformBlock;
        var indexCam = ublock[NAME_BASIS];
        if (indexCam != null)
            gl.uniformBlockBinding(glp, indexCam, CLASS.UNIFORMINDEX_BASIS);
        var indexObj = ublock[NAME_OBJ];
        if (indexObj != null)
            gl.uniformBlockBinding(glp, indexObj, CLASS.UNIFORMINDEX_OBJ);
        mat.apply(gl);
        var dataobj = pipeline.shaderDataObj;
        var mtx = GLMath_1.mat4.Identity;
        dataobj.setMtxModel(mtx);
        pipeline.updateUniformBufferObject(dataobj);
        gl.bindVertexArray(this.m_vao);
        var indiceDesc = mesh.indiceDesc;
        gl.drawElements(indiceDesc.topology, indiceDesc.indiceCount, indiceDesc.type, indiceDesc.offset);
        gl.bindVertexArray(null);
    };
    PassGizmos.prototype.genMesh = function () {
        var builder = new MeshBuilder_1.MeshBuilder(Mesh_1.MeshTopology.Lines);
        builder.addLine(GLMath_1.glmath.vec3(-50, 0, 0), GLMath_1.glmath.vec3(50, 0, 0));
        builder.addLine(GLMath_1.glmath.vec3(0, 0, -50), GLMath_1.glmath.vec3(0, 0, 50));
        builder.addLine(GLMath_1.glmath.vec3(-5, 0, -5), GLMath_1.glmath.vec3(5, 0, -5));
        builder.addLine(GLMath_1.glmath.vec3(5, 0, -5), GLMath_1.glmath.vec3(5, 0, 5));
        builder.addLine(GLMath_1.glmath.vec3(5, 0, 5), GLMath_1.glmath.vec3(-5, 0, 5));
        builder.addLine(GLMath_1.glmath.vec3(-5, 0, 5), GLMath_1.glmath.vec3(-5, 0, -5));
        return builder.genMesh();
    };
    __decorate([
        ShaderFX_1.ShaderFile("gizmos")
    ], PassGizmos, "SH_gizmos", void 0);
    return PassGizmos;
}(RenderPass_1.RenderPass));
exports.PassGizmos = PassGizmos;
