"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Shader_1 = require("../shaderfx/Shader");
var MeshRender_1 = require("../MeshRender");
var Camera_1 = require("../Camera");
var Material_1 = require("../Material");
var Mesh_1 = require("../Mesh");
var ShaderFX_1 = require("../shaderfx/ShaderFX");
var RenderPass_1 = require("./RenderPass");
var Skybox_1 = require("../Skybox");
var PassSkybox = /** @class */ (function (_super) {
    __extends(PassSkybox, _super);
    function PassSkybox(pipeline) {
        var _this = _super.call(this, pipeline) || this;
        _this.m_lastSkyboxType = Skybox_1.SkyboxType.Tex360;
        var deftags = new Shader_1.ShaderTags();
        deftags.blend = false;
        deftags.zwrite = true;
        deftags.ztest = Shader_1.Comparison.LEQUAL;
        deftags.culling = Shader_1.CullingMode.Back;
        deftags.fillDefaultVal();
        _this.m_tags = deftags;
        var mat = new Material_1.Material(pipeline.graphicRender.shaderLib.shaderSkybox);
        mat.setFlag("ENVMAP_TYPE", "TEX", true);
        var skyrender = new MeshRender_1.MeshRender(Mesh_1.Mesh.Quad, mat);
        _this.m_skyrender = skyrender;
        return _this;
    }
    PassSkybox.prototype.release = function () {
        this.m_skyrender.release(this.pipeline.GLCtx);
        this.m_skyrender = null;
        this.m_lastTex = null;
        _super.prototype.release.call(this);
    };
    PassSkybox.prototype.render = function (scene) {
        var camera = scene.mainCamera;
        if (camera.clearType != Camera_1.ClearType.Skybox || camera.skybox == null)
            return;
        var pipeline = this.pipeline;
        pipeline.bindTargetFrameBuffer();
        pipeline.stateCache.reset(this.m_tags);
        var skyboxrender = this.m_skyrender;
        var mat = skyboxrender.material;
        var texskybox = camera.skybox;
        if (texskybox.type != this.m_lastSkyboxType) {
            var newtype = texskybox.type;
            this.m_lastSkyboxType = newtype;
            mat.setFlag("ENVMAP_TYPE", newtype, true);
            var rawtex_1 = texskybox.rawTex;
            mat.setTexture(ShaderFX_1.ShaderFX.UNIFORM_MAIN_TEXTURE, rawtex_1);
        }
        var rawtex = texskybox.rawTex;
        if (rawtex != null && rawtex != this.m_lastTex) {
            var tex = texskybox.rawTex;
            this.m_lastTex = tex;
            mat.setTexture(ShaderFX_1.ShaderFX.UNIFORM_MAIN_TEXTURE, tex);
        }
        pipeline.drawMeshRender(skyboxrender);
    };
    return PassSkybox;
}(RenderPass_1.RenderPass));
exports.PassSkybox = PassSkybox;
