/// <reference types="webgl2" />
import { vec3, vec4, mat4, mat3 } from "../math/GLMath";
declare class ShaderBuffer {
    private minoff;
    private maxoff;
    private m_isdirty;
    private rawbuffer;
    private byteArray;
    private dataView;
    constructor(bytesize: number);
    readonly isDirty: boolean;
    readonly offsetMin: number;
    readonly offsetMax: number;
    readonly raw: Uint8Array;
    setDirty(d: boolean): void;
    set(fxbuffer: ShaderBuffer, off: number): void;
    setOfView(fxview: ShaderBufferView): void;
    setOfSubData(fxsubdata: ShaderSubData): void;
    private setMinMaxOffset;
    setFloat(byteOffset: number, value: number): void;
    setUint32(byteOffset: number, value: number): void;
    setVec3(byteOffset: number, value: vec3): void;
    setVec4(byteOffset: number, value: vec4): void;
    setMat4(byteOffset: number, value: mat4): void;
    setMat3(byteOffset: number, value: mat3): void;
}
declare class ShaderBufferView {
    private fxbuffer;
    private base;
    readonly buffer: ShaderBuffer;
    readonly viewbase: number;
    constructor(buffer: ShaderBuffer, byteoffset: number, bytelength?: number);
    setFloat(byteoffset: number, val: number): void;
    setUint32(byteoffset: number, val: number): void;
    setVec3(byteoffset: number, val: vec3): void;
    setVec4(byteoffset: number, val: vec4): void;
    setMat4(byteoffset: number, val: mat4): void;
    setMat3(byteoffset: number, val: mat3): void;
}
export declare class ShaderSubData {
    protected view: ShaderBufferView;
    protected m_seperated: boolean;
    readonly baseOffset: number;
    readonly byteLength: number;
    constructor(data: ShaderData, length: number, offset: number);
    readonly isSeperated: boolean;
    readonly bufferView: ShaderBufferView;
    readonly isDirty: boolean;
    setDirty: boolean;
}
export declare class ShaderData {
    protected buffer: ShaderBuffer;
    readonly fxbuffer: ShaderBuffer;
    constructor(bytelength: number);
    submitBuffer(gl: WebGL2RenderingContext, glbuffer: WebGLBuffer): boolean;
}
export {};
