import { ShaderVariant } from "./ShaderVariant";
import { ShaderSource } from "./ShaderSource";
import { GLContext } from "../gl/GLContext";
import { Shader } from "./Shader";
export declare class ShaderFX {
    static variants: {
        [key: string]: ShaderVariant;
    };
    private static s_variantsLinked;
    static registVariant(variant: ShaderVariant): void;
    static linkAllVariant(): void;
    static getShader(): void;
    static compileShaders(glctx: GLContext, source: ShaderSource): Shader;
    static isInternalUniformBlockName(blockname: string): boolean;
    static VARIANT_SHADERFX_OBJ: string;
    static VARIANT_SHADERFX_CAMERA: string;
    static VARIANT_SHADERFX_BASIS: string;
    static VARIANT_SHADERFX_LIGHT: string;
    static VARIANT_SHADERFX_SHADOWMAP: string;
    static VARIANT_SHADERFX_LIGHTING: string;
    static OPT_SHADOWMAP_SHADOW: string;
    static OPT_SHADOWMAP_SHADOW_ON: string;
    static OPT_SHADOWMAP_SHADOW_OFF: string;
    static ATTR_aPosition: string;
    static ATTR_aUV: string;
    static ATTR_aNormal: string;
    static UNIFORM_BASIS: string;
    static UNIFORM_OBJ: string;
    static UNIFORM_LIGHT: string;
    static UNIFORM_SHADOWMAP: string;
    static UNIFORM_SHADOWMAP_SAMPLER: string;
    static UNIFORM_MAIN_COLOR: string;
    static UNIFORM_MAIN_TEXTURE: string;
    static readonly GL_TEXTURE_FB: number;
    static readonly GL_TEXTURE_DEPTH: number;
    static readonly GL_TEXTURE_TEMP: number;
    static readonly GL_TEXTURE_DEF_TEX: number;
    static readonly GL_TEXTURE_FB_ID: number;
    static readonly GL_TEXTURE_TEMP_ID: number;
    static readonly GL_TEXTURE_DEF_TEX_ID: number;
    static readonly GL_SH_TEXTURE0: number;
    static readonly GL_SH_TEXTURE1: number;
    static readonly GL_SH_TEXTURE2: number;
    static readonly GL_SH_TEXTURE3: number;
    static readonly GL_SH_TEXTURE4: number;
    static readonly GL_SH_TEXTURE5: number;
    static readonly GL_SH_TEXTURE6: number;
    static readonly GL_SH_TEXTURE7: number;
    static readonly GL_SH_TEXTURE0_ID: number;
    static readonly GL_SH_TEXTURE1_ID: number;
    static readonly GL_SH_TEXTURE2_ID: number;
    static readonly GL_SH_TEXTURE3_ID: number;
    static readonly GL_SH_TEXTURE4_ID: number;
    static readonly GL_SH_TEXTURE5_ID: number;
    static readonly GL_SH_TEXTURE6_ID: number;
    static readonly GL_SH_TEXTURE7_ID: number;
    static readonly GL_SHADOWMAP_TEX0: number;
    static readonly GL_SHADOWMAP_TEX1: number;
    static readonly GL_SHADOWMAP_TEX2: number;
    static readonly GL_SHADOWMAP_TEX3: number;
    static readonly GL_SHADOWMAP_TEX0_ID: number;
    static readonly GL_SHADOWMAP_TEX1_ID: number;
    static readonly GL_SHADOWMAP_TEX2_ID: number;
    static readonly GL_SHADOWMAP_TEX3_ID: number;
}
export declare function ShaderFile(vsfile: string, psfile?: string): (target: any, key: string) => void;
export declare function ShaderInc(filename: string): (target: any, key: string) => void;
