"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ShaderFX_1 = require("./ShaderFX");
var ShaderBuffer_1 = require("./ShaderBuffer");
var GLMath_1 = require("../math/GLMath");
var ShaderFXLibs = /** @class */ (function () {
    function ShaderFXLibs(glctx) {
        this.glctx = glctx;
    }
    Object.defineProperty(ShaderFXLibs.prototype, "shaderUnlitColor", {
        get: function () {
            if (this.m_unlitColor == null) {
                this.m_unlitColor = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_unitColor);
            }
            return this.m_unlitColor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderUnlitTexture", {
        get: function () {
            if (this.m_unlitTexture == null) {
                this.m_unlitTexture = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_unlitTexture);
            }
            return this.m_unlitTexture;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderUVvalue", {
        get: function () {
            if (this.m_uvValue == null) {
                this.m_uvValue = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_uvValue);
            }
            return this.m_uvValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderDiffuse", {
        get: function () {
            if (this.m_diffuse == null) {
                this.m_diffuse = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_diffuse);
            }
            return this.m_diffuse;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderSkybox", {
        get: function () {
            if (this.m_skybox == null) {
                this.m_skybox = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_skybox);
            }
            return this.m_skybox;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderPbrMetallicRoughness", {
        get: function () {
            if (this.m_pbrMetallicRoughness == null) {
                this.m_pbrMetallicRoughness = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_pbrMetallicRoughness);
            }
            return this.m_pbrMetallicRoughness;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderDepth", {
        get: function () {
            if (this.m_depth == null) {
                this.m_depth = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_depth);
            }
            return this.m_depth;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderShadowMap", {
        get: function () {
            if (this.m_shadermap == null) {
                this.m_shadermap = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_shadowmap);
            }
            return this.m_shadermap;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderBlit", {
        get: function () {
            if (this.m_blit == null) {
                this.m_blit = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_blit);
            }
            return this.m_blit;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderFXLibs.prototype, "shaderSprite", {
        get: function () {
            if (this.m_sprite == null) {
                this.m_sprite = ShaderFX_1.ShaderFX.compileShaders(this.glctx, ShaderFXLibs.SH_sprite);
            }
            return this.m_sprite;
        },
        enumerable: true,
        configurable: true
    });
    ShaderFXLibs.prototype.release = function () {
    };
    ShaderFXLibs.prototype.reload = function () {
    };
    ShaderFXLibs.SH_PBR_BaseColorFactor = "uColor";
    ShaderFXLibs.SH_PBR_BaseColorTexture = "uSampler";
    ShaderFXLibs.SH_PBR_MetallicFactor = "uMetallic";
    ShaderFXLibs.SH_PBR_RoughnessFactor = "uRoughness";
    ShaderFXLibs.SH_PBR_MetallicRoughnessTexture = "uTexMetallicRoughness";
    ShaderFXLibs.SH_PBR_EmissiveFactor = "uEmissive";
    ShaderFXLibs.SH_PBR_EmissiveTexture = "uTexEmissive";
    __decorate([
        ShaderFX_1.ShaderFile("UnlitColor")
    ], ShaderFXLibs, "SH_unitColor", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("UnlitTexture")
    ], ShaderFXLibs, "SH_unlitTexture", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("uvValue")
    ], ShaderFXLibs, "SH_uvValue", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("diffuse")
    ], ShaderFXLibs, "SH_diffuse", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("skybox")
    ], ShaderFXLibs, "SH_skybox", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("pbrMetallicRoughness")
    ], ShaderFXLibs, "SH_pbrMetallicRoughness", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("depth")
    ], ShaderFXLibs, "SH_depth", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("shadowmap")
    ], ShaderFXLibs, "SH_shadowmap", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("blit")
    ], ShaderFXLibs, "SH_blit", void 0);
    __decorate([
        ShaderFX_1.ShaderFile("sprite")
    ], ShaderFXLibs, "SH_sprite", void 0);
    __decorate([
        ShaderFX_1.ShaderInc(ShaderFX_1.ShaderFX.VARIANT_SHADERFX_BASIS)
    ], ShaderFXLibs, "SHADERFX_BASIS", void 0);
    __decorate([
        ShaderFX_1.ShaderInc(ShaderFX_1.ShaderFX.VARIANT_SHADERFX_LIGHT)
    ], ShaderFXLibs, "SHADERFX_LIGHT", void 0);
    __decorate([
        ShaderFX_1.ShaderInc(ShaderFX_1.ShaderFX.VARIANT_SHADERFX_LIGHTING)
    ], ShaderFXLibs, "SHADERFX_LIGHTING", void 0);
    __decorate([
        ShaderFX_1.ShaderInc(ShaderFX_1.ShaderFX.VARIANT_SHADERFX_SHADOWMAP)
    ], ShaderFXLibs, "SHADERFX_SHADOWMAP", void 0);
    return ShaderFXLibs;
}());
exports.ShaderFXLibs = ShaderFXLibs;
/** Shader DataBuffer */
var ShaderDataUniformObj = /** @class */ (function (_super) {
    __extends(ShaderDataUniformObj, _super);
    function ShaderDataUniformObj() {
        var _this = this;
        var buffersize = 16 * 4;
        _this = _super.call(this, buffersize) || this;
        return _this;
    }
    ShaderDataUniformObj.prototype.setMtxModel = function (mtx) {
        this.buffer.setMat4(0, mtx);
    };
    ShaderDataUniformObj.UNIFORM_OBJ = "UNIFORM_OBJ";
    return ShaderDataUniformObj;
}(ShaderBuffer_1.ShaderData));
exports.ShaderDataUniformObj = ShaderDataUniformObj;
var ShaderDataUniformLight = /** @class */ (function (_super) {
    __extends(ShaderDataUniformLight, _super);
    function ShaderDataUniformLight() {
        var _this = this;
        var buffersize = (8 * 4 + 4) * 4;
        _this = _super.call(this, buffersize) || this;
        return _this;
    }
    ShaderDataUniformLight.prototype.setLightData = function (pos, type, index) {
        var offset = index * 32;
        var buffer = this.buffer;
        buffer.setVec3(offset, pos);
        buffer.setFloat(offset + 12, type);
    };
    ShaderDataUniformLight.prototype.setLightColorIntensity = function (col, intensity, index) {
        var offset = index * 32 + 16;
        var buffer = this.buffer;
        buffer.setVec3(offset, col);
        buffer.setFloat(offset + 12, intensity);
    };
    ShaderDataUniformLight.prototype.setAmbientColor = function (ambient) {
        this.buffer.setVec4(128, ambient);
    };
    ShaderDataUniformLight.UNIFORM_LIGHT = "UNIFORM_LIGHT";
    return ShaderDataUniformLight;
}(ShaderBuffer_1.ShaderData));
exports.ShaderDataUniformLight = ShaderDataUniformLight;
var ShaderDataUniformShadowMap = /** @class */ (function (_super) {
    __extends(ShaderDataUniformShadowMap, _super);
    function ShaderDataUniformShadowMap() {
        var _this = this;
        var buffersize = 16 * 4 * 4 + 4;
        _this = _super.call(this, buffersize) || this;
        return _this;
    }
    ShaderDataUniformShadowMap.prototype.setLightMtx = function (mtx, index) {
        this.buffer.setMat4(index * 64, mtx);
    };
    ShaderDataUniformShadowMap.prototype.setShadowDistance = function (dist) {
    };
    ShaderDataUniformShadowMap.prototype.setCascadeCount = function (count) {
    };
    return ShaderDataUniformShadowMap;
}(ShaderBuffer_1.ShaderData));
exports.ShaderDataUniformShadowMap = ShaderDataUniformShadowMap;
var ShaderDataBasis = /** @class */ (function (_super) {
    __extends(ShaderDataBasis, _super);
    function ShaderDataBasis() {
        var _this = _super.call(this, 32 + 224 + 48) || this;
        _this.render = new ShaderDataRender(_this);
        _this.camrea = new ShaderDataCamera(_this);
        _this.ambientfog = new ShaderDataAmbientFog(_this);
        return _this;
    }
    ShaderDataBasis.prototype.updateDataBasic = function (data) {
        if (data.isSeperated) {
            this.buffer.setOfSubData(data);
            data.setDirty = false;
        }
    };
    ShaderDataBasis.prototype.updateDataCamera = function (data) {
        if (data.isSeperated) {
            this.buffer.setOfSubData(data);
            data.setDirty = false;
        }
    };
    ShaderDataBasis.prototype.updateDateAmbeintFog = function (data) {
        if (data.isSeperated) {
            this.buffer.setOfSubData(data);
            data.setDirty = false;
        }
    };
    ShaderDataBasis.prototype.submitBuffer = function (gl, glbuffer) {
        var min = this.buffer.offsetMin;
        var max = this.buffer.offsetMax;
        var t = _super.prototype.submitBuffer.call(this, gl, glbuffer);
        //if(t)console.log(min,max);
        return t;
    };
    return ShaderDataBasis;
}(ShaderBuffer_1.ShaderData));
exports.ShaderDataBasis = ShaderDataBasis;
var ShaderDataRender = /** @class */ (function (_super) {
    __extends(ShaderDataRender, _super);
    //[0,16] vec4 _screenparam_
    //[16,32] highp vec4 _time_
    function ShaderDataRender(data) {
        return _super.call(this, data, 32, 0) || this;
    }
    ShaderDataRender.prototype.setScreenParam = function (width, height) {
        this.view.setVec4(0, new GLMath_1.vec4([width, height, 1.0 / width, 1.0 / height]));
    };
    ShaderDataRender.prototype.setTime = function (t, ts) {
        this.view.setVec4(16, new GLMath_1.vec4([t, ts, Math.sin(t), Math.cos(t)]));
    };
    return ShaderDataRender;
}(ShaderBuffer_1.ShaderSubData));
exports.ShaderDataRender = ShaderDataRender;
var ShaderDataCamera = /** @class */ (function (_super) {
    __extends(ShaderDataCamera, _super);
    //[0,16] vec4 _camera_pos_;
    //[16,80] mat4 _camera_mtx_view_;
    //[80,96] vec4 _camera_projparam_;
    //[96,160] mat4 _camera_mtx_proj_;
    //[160,224] mat4 _camera_mtx_invproj_;
    function ShaderDataCamera(data) {
        return _super.call(this, data, 224, 32) || this;
    }
    ShaderDataCamera.prototype.setProjParam = function (near, far) {
        this.view.setVec4(80, new GLMath_1.vec4([near, far, 1.0 / near, 1.0 / far]));
    };
    ShaderDataCamera.prototype.setCameraPos = function (pos) {
        this.view.setVec3(0, pos);
    };
    ShaderDataCamera.prototype.setCameraMtxView = function (view) {
        this.view.setMat4(16, view);
    };
    ShaderDataCamera.prototype.setCameraMtxProj = function (proj, invproj) {
        var view = this.view;
        view.setMat4(96, proj);
        if (invproj == null) {
            view.setMat4(160, proj.inverse());
        }
        else {
            view.setMat4(160, invproj);
        }
    };
    return ShaderDataCamera;
}(ShaderBuffer_1.ShaderSubData));
exports.ShaderDataCamera = ShaderDataCamera;
/**
 *
 */
var ShaderDataAmbientFog = /** @class */ (function (_super) {
    __extends(ShaderDataAmbientFog, _super);
    //[0,16] lowp vec4 _ambientcolor_;
    //[16,32] vec4 _fogcolor_;
    //[32,48] vec4 _fogparam_;
    function ShaderDataAmbientFog(data) {
        return _super.call(this, data, 48, 256) || this;
    }
    ShaderDataAmbientFog.prototype.setAmbientColor = function (col) {
        this.view.setVec4(0, col);
    };
    ShaderDataAmbientFog.prototype.setFogColor = function (col) {
        this.view.setVec4(16, col);
    };
    ShaderDataAmbientFog.prototype.setFogParam = function (param) {
        this.view.setVec4(32, param);
    };
    return ShaderDataAmbientFog;
}(ShaderBuffer_1.ShaderSubData));
exports.ShaderDataAmbientFog = ShaderDataAmbientFog;
