import { IncludeIndex, ShaderOptions } from "./ShaderVariant";
import { VariantsGroup } from "./ShaderSource";
export declare class ShaderPreprocessor {
    static readonly REGEX_INCLUDE: RegExp;
    static readonly REGEX_OPTIONS: RegExp;
    static processVariantInclude(line: string, lineindex: number): IncludeIndex;
    static processUnifiedSource(unified: string, name?: string): [string, string];
    static getFunctionPosIndex(text: string, entry: string): [number, number];
    static Seperate(str: string, spos: number, epos: number): [string, string];
    static TrimEmptyLine(str: string): string;
    /**
     * Process shader source #include macros
     * @param line
     * @param variants
     * @returns line:string variantName:string
     */
    static processSourceInclude(line: string, variants: VariantsGroup): [string, string];
    static processOptions(line: string): [string, ShaderOptions];
}
