import { ShaderVariant, ShaderOptions } from "./ShaderVariant";
import { ShaderTags } from "./Shader";
export declare type VariantsGroup = {
    [key: string]: ShaderVariant;
};
export declare class ShaderSource {
    variants: string[];
    private vs;
    private ps;
    private m_built;
    private m_shaderTag;
    name: string;
    optionsList: ShaderOptions[];
    constructor(vs: string, ps?: string, name?: string);
    static create(unified: string, name?: string): ShaderSource;
    static load(url: string, name?: string): Promise<ShaderSource>;
    readonly isBuilt: boolean;
    readonly vertex: string;
    readonly pixel: string;
    readonly tags: ShaderTags;
    buildShader(v: VariantsGroup): boolean;
    addVariant(vname: string): boolean;
    private addOptions;
    ProcessShader(source: string, variants: VariantsGroup): string;
    private processShaderTag;
    setShaderTagProperty(pname: string, tagval: string, enumtype: any): void;
    injectCompileFlags(flags: string): [string, string];
}
