"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Shader_1 = require("./Shader");
var ShaderPreprocessor_1 = require("./ShaderPreprocessor");
var GLUtility_1 = require("../gl/GLUtility");
var ShaderSource = /** @class */ (function () {
    function ShaderSource(vs, ps, name) {
        this.m_built = false;
        this.m_shaderTag = null;
        this.optionsList = [];
        this.ps = ps;
        this.vs = vs;
        this.name = name;
    }
    ShaderSource.create = function (unified, name) {
        var _a = ShaderPreprocessor_1.ShaderPreprocessor.processUnifiedSource(unified, name), vs = _a[0], ps = _a[1];
        return new ShaderSource(vs, ps, name);
    };
    ShaderSource.load = function (url, name) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (url == null || url === '')
                    return [2 /*return*/, null];
                return [2 /*return*/, new Promise(function (res, rej) { return __awaiter(_this, void 0, void 0, function () {
                        var glsl, source;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, GLUtility_1.GLUtility.HttpGet(url, "text")];
                                case 1:
                                    glsl = _a.sent();
                                    source = ShaderSource.create(glsl, name);
                                    res(source);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    Object.defineProperty(ShaderSource.prototype, "isBuilt", {
        get: function () {
            return this.m_built;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderSource.prototype, "vertex", {
        get: function () {
            return this.vs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderSource.prototype, "pixel", {
        get: function () {
            return this.ps;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ShaderSource.prototype, "tags", {
        get: function () {
            return this.m_shaderTag;
        },
        enumerable: true,
        configurable: true
    });
    ShaderSource.prototype.buildShader = function (v) {
        if (this.m_built)
            return true;
        var gen_vs = this.ProcessShader(this.vs, v);
        var gen_ps = this.ProcessShader(this.ps, v);
        this.ps = gen_ps;
        this.vs = gen_vs;
        this.m_built = true;
        return true;
    };
    ShaderSource.prototype.addVariant = function (vname) {
        if (this.variants == null) {
            this.variants = [];
            this.variants.push(vname);
            return true;
        }
        var variants = this.variants;
        if (variants.indexOf(vname) < 0) {
            variants.push(vname);
            return true;
        }
        return false;
    };
    ShaderSource.prototype.addOptions = function (variant) {
        var options = variant.options;
        if (options == null)
            return;
        var optlist = this.optionsList;
        for (var i = 0, len = options.length; i < len; i++) {
            optlist.push(options[i]);
        }
    };
    ShaderSource.prototype.ProcessShader = function (source, variants) {
        var lines = source.split('\n');
        for (var i = 0, len = lines.length; i < len; i++) {
            var line = lines[i];
            var pinclude = ShaderPreprocessor_1.ShaderPreprocessor.processSourceInclude(line, variants);
            if (pinclude != null) {
                lines[i] = pinclude[0];
                var vname = pinclude[1];
                var added = this.addVariant(vname);
                if (added)
                    this.addOptions(variants[vname]);
                continue;
            }
            var poptions = ShaderPreprocessor_1.ShaderPreprocessor.processOptions(line);
            if (poptions != null) {
                lines[i] = poptions[0];
                this.optionsList.push(poptions[1]);
                continue;
            }
            lines[i] = this.processShaderTag(line);
        }
        return lines.join('\n').trim();
    };
    ShaderSource.prototype.processShaderTag = function (line) {
        line = line.trim();
        var tags = this.m_shaderTag;
        var regex2 = /#(ztest|zwrite|queue) ([\w]+)/;
        var match = line.match(regex2);
        if (match != null) {
            if (tags == null) {
                tags = new Shader_1.ShaderTags();
                this.m_shaderTag = tags;
            }
            var tagtype = match[1].toLowerCase();
            var tagval = match[2].toUpperCase();
            switch (tagtype) {
                case "ztest":
                    this.setShaderTagProperty('ztest', tagval, Shader_1.Comparison);
                    break;
                case "zwrite":
                    {
                        var val = tagval === 'OFF' ? 0 : (tagval === "ON" ? 1 : -1);
                        if (val == -1) {
                            throw new Error("invalid zwrite tag [" + match[2] + "]");
                        }
                        var newval = val == 1;
                        if (tags.zwrite == null || tags.zwrite == newval) {
                            tags.zwrite = newval;
                        }
                        else {
                            throw new Error("zwrite tag conflict");
                        }
                    }
                    break;
                case "queue":
                    tagval = tagval.charAt(0).toUpperCase() + match[2].slice(1);
                    this.setShaderTagProperty('queue', tagval, Shader_1.RenderQueue);
                    break;
                case "cull":
                    {
                        var cullingmode = Shader_1.CullingMode.Back;
                        switch (tagval) {
                            case "ALL":
                                cullingmode = Shader_1.CullingMode.FRONT_AND_BACK;
                                break;
                            case "BACK":
                                cullingmode = Shader_1.CullingMode.Back;
                                break;
                            case "FRONT":
                                cullingmode = Shader_1.CullingMode.Front;
                                break;
                            case "NONE":
                                cullingmode = Shader_1.CullingMode.None;
                                break;
                            default:
                                throw new Error('invalid culling mode');
                        }
                        if (tags.culling == null) {
                            tags.culling = cullingmode;
                        }
                        else {
                            if (tags.culling != cullingmode) {
                                throw new Error("culling mode confliect : " + cullingmode + " " + tags.culling);
                            }
                        }
                    }
                default:
                    throw new Error("unknown shader tag [" + line + "]");
            }
            line = '';
        }
        var regexblend = /#blend ([\w]+) ([\w]+)[\s]*([\w]+)*/;
        match = line.match(regexblend);
        if (match != null) {
            console.log('process blend');
            if (tags == null) {
                tags = new Shader_1.ShaderTags();
                this.m_shaderTag = tags;
            }
            tags.blend = true;
            var tarfs = match[1].toUpperCase();
            var tarfd = match[2].toUpperCase();
            var tarop = match[3];
            if (tarop == null) {
                tarop = 'ADD';
            }
            else {
                tarop = tarop.toUpperCase();
                var op = Shader_1.BlendOperator[tarop];
                if (op == null)
                    throw new Error("invalid blend operator [" + tarop + "]");
            }
            var fs = Shader_1.BlendFactor[tarfs];
            var fd = Shader_1.BlendFactor[tarfd];
            if (fs == null)
                throw new Error("invalid blend factor [" + match[1] + "]");
            if (fd == null)
                throw new Error("invalid blend factor [" + match[2] + "]");
            var newop = Shader_1.BlendFactor[tarop];
            if (tags.blendOp != null && (tags.blendOp != newop || tags.blendFactorDst != fd || tags.blendFactorSrc != fs)) {
                throw new Error("bleng tag conflict [" + line + "]");
            }
            else {
                tags.blendOp = newop;
                tags.blendFactorSrc = fs;
                tags.blendFactorDst = fd;
            }
            line = '';
        }
        return line;
    };
    ShaderSource.prototype.setShaderTagProperty = function (pname, tagval, enumtype) {
        var tags = this.m_shaderTag;
        var val = enumtype[tagval];
        if (val == undefined) {
            throw new Error("invalid " + pname + " tag [" + tagval + "]");
        }
        if (tags[pname] == null) {
            tags[pname] = val;
        }
        else {
            if (tags[pname] != val) {
                throw new Error(pname + " tag conflict [" + Shader_1.Comparison[tags[pname]] + "] [" + tagval + "]");
            }
        }
    };
    ShaderSource.prototype.injectCompileFlags = function (flags) {
        var prefix = '#version 300 es\n';
        var vs = this.vs;
        var ps = this.pixel;
        if (!vs.startsWith(prefix)) {
            vs = prefix + '#define SHADER_VS\r\n' + flags + vs;
        }
        else {
            vs = prefix + '#define SHADER_VS\r\n' + flags + vs.slice(15);
        }
        if (!ps.startsWith(prefix)) {
            ps = prefix + '#define SHADER_PS\r\n' + flags + ps;
        }
        else {
            ps = prefix + '#define SHADER_PS\r\n' + flags + ps.slice(15);
        }
        return [vs, ps];
    };
    return ShaderSource;
}());
exports.ShaderSource = ShaderSource;
