export declare type IncludeIndex = {
    key: string;
    line: number;
};
export declare class ShaderVariant {
    includes: IncludeIndex[];
    lines: string[];
    variantName: string;
    linked: boolean;
    private m_sources;
    options: ShaderOptions[];
    constructor(variantName: string, source: string);
    static load(url: string, variantName: string): Promise<ShaderVariant>;
    readonly sources: string;
    link(variances: {
        [key: string]: ShaderVariant;
    }): void;
    private process;
}
export declare class ShaderOptions {
    flag: string;
    values: string[];
    default: string;
    constructor(flag?: string, val?: string);
}
export declare class ShaderOptionsConfig {
    private m_hashCode;
    private m_dirty;
    private m_optmap;
    private m_options;
    private m_compileFlags;
    constructor(opts?: ShaderOptions[]);
    getFlag(key: string): string;
    verifyFlag(key: string, value: string): boolean;
    setFlag(key: string, value: string): boolean;
    readonly hashCode: number;
    compileOptions(): void;
    private calculateHashCode;
    readonly compileFlag: string;
    /**
     * Deep Clone
     */
    clone(): ShaderOptionsConfig;
}
