"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Utility_1 = require("../Utility");
var ShaderPreprocessor_1 = require("./ShaderPreprocessor");
var GLUtility_1 = require("../gl/GLUtility");
var ShaderVariant = /** @class */ (function () {
    function ShaderVariant(variantName, source) {
        this.includes = [];
        this.linked = false;
        this.options = [];
        this.variantName = variantName;
        this.process(variantName, source);
    }
    ShaderVariant.load = function (url, variantName) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (url == null || url === '')
                    return [2 /*return*/, null];
                return [2 /*return*/, new Promise(function (res, rej) { return __awaiter(_this, void 0, void 0, function () {
                        var glsl, source;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, GLUtility_1.GLUtility.HttpGet(url, "text")];
                                case 1:
                                    glsl = _a.sent();
                                    source = new ShaderVariant(variantName, glsl);
                                    res(source);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    Object.defineProperty(ShaderVariant.prototype, "sources", {
        get: function () {
            return this.m_sources;
        },
        enumerable: true,
        configurable: true
    });
    ShaderVariant.prototype.link = function (variances) {
        if (this.linked)
            return;
        var includes = this.includes;
        if (includes.length == 0) {
            this.linked = true;
        }
        else {
            for (var i = 0, len = includes.length; i < len; i++) {
                var inc = includes[i];
                var lib = variances[inc.key];
                if (lib == null) {
                    throw new Error("can't find variant : [" + inc.key + "]");
                }
                if (!lib.linked) {
                    lib.link(variances);
                }
                if (!lib.linked) {
                    throw new Error("variance [" + lib.variantName + "] link: failed");
                }
                this.lines[inc.line] = lib.sources;
            }
            this.linked = true;
        }
        this.m_sources = this.lines.join('\n');
        //console.log(`link success ${this.variantName}`);
    };
    ShaderVariant.prototype.process = function (variantName, source) {
        source = "\n        #ifndef " + variantName + "\n        #define " + variantName + "\n        " + source + "\n        #endif\n        ";
        var lines = source.split('\n');
        for (var i = 0, len = lines.length; i < len; i++) {
            var line = lines[i];
            var pinclude = ShaderPreprocessor_1.ShaderPreprocessor.processVariantInclude(line, i);
            if (pinclude != null) {
                this.includes.push(pinclude);
                continue;
            }
            var poptions = ShaderPreprocessor_1.ShaderPreprocessor.processOptions(line);
            if (poptions != null) {
                lines[i] = poptions[0];
                this.options.push(poptions[1]);
                continue;
            }
        }
        this.lines = lines;
    };
    return ShaderVariant;
}());
exports.ShaderVariant = ShaderVariant;
var ShaderOptions = /** @class */ (function () {
    function ShaderOptions(flag, val) {
        this.flag = flag;
        this.default = val;
    }
    return ShaderOptions;
}());
exports.ShaderOptions = ShaderOptions;
var ShaderOptionsConfig = /** @class */ (function () {
    function ShaderOptionsConfig(opts) {
        this.m_hashCode = 0;
        this.m_dirty = false;
        this.m_optmap = {};
        if (opts == null)
            return;
        this.m_options = opts;
        var optmap = this.m_optmap;
        for (var i = 0, len = opts.length; i < len; i++) {
            var opt = opts[i];
            optmap[opt.flag] = opt.default;
        }
        this.compileOptions();
    }
    ShaderOptionsConfig.prototype.getFlag = function (key) {
        return this.m_optmap[key];
    };
    ShaderOptionsConfig.prototype.verifyFlag = function (key, value) {
        var curval = this.m_optmap[key];
        if (curval == null) {
            console.warn("invalid shader option flag: [" + key + "]");
            return false;
        }
        var options = this.m_options;
        for (var i = 0, len = options.length; i < len; i++) {
            var opt = options[i];
            if (opt.flag === key) {
                if (opt.values.indexOf(value) >= 0) {
                    return true;
                }
                else {
                    console.warn("invalid shader option value : [" + key + ": " + value + "]");
                    return false;
                }
            }
        }
    };
    ShaderOptionsConfig.prototype.setFlag = function (key, value) {
        this.m_optmap[key] = value;
        this.m_dirty = true;
        return true;
    };
    Object.defineProperty(ShaderOptionsConfig.prototype, "hashCode", {
        get: function () {
            if (this.m_dirty) {
                this.compileOptions();
            }
            return this.m_hashCode;
        },
        enumerable: true,
        configurable: true
    });
    ShaderOptionsConfig.prototype.compileOptions = function () {
        this.m_dirty = false;
        var flags = '';
        var hashstr = [];
        var optmap = this.m_optmap;
        for (var key in optmap) {
            var val = optmap[key];
            if (val == null)
                throw new Error("shader flag is null [" + key + "]");
            var hash = " " + key + "_" + val;
            hashstr.push(hash);
            var flag = "#define " + hash + "\n";
            flags += flag;
        }
        this.m_compileFlags = flags;
        this.calculateHashCode(hashstr);
    };
    ShaderOptionsConfig.prototype.calculateHashCode = function (hashstr) {
        hashstr.sort();
        this.m_hashCode = Utility_1.Utility.Hashfnv32a(hashstr.join(' '));
    };
    Object.defineProperty(ShaderOptionsConfig.prototype, "compileFlag", {
        get: function () {
            if (this.m_dirty) {
                this.compileOptions();
            }
            return this.m_compileFlags;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Deep Clone
     */
    ShaderOptionsConfig.prototype.clone = function () {
        var optconfig = new ShaderOptionsConfig();
        optconfig.m_hashCode = this.m_hashCode;
        optconfig.m_dirty = this.m_dirty;
        optconfig.m_options = this.m_options;
        optconfig.m_compileFlags = this.m_compileFlags;
        optconfig.m_optmap = Utility_1.Utility.cloneMap(this.m_optmap);
        return optconfig;
    };
    return ShaderOptionsConfig;
}());
exports.ShaderOptionsConfig = ShaderOptionsConfig;
