"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Scene_1 = require("../Scene");
var GameObject_1 = require("../GameObject");
var Camera_1 = require("../Camera");
var GraphicsRender_1 = require("../GraphicsRender");
var Light_1 = require("../Light");
var DebugEntry_1 = require("../DebugEntry");
var Utility_1 = require("../Utility");
var Input_1 = require("../Input");
var SceneManager_1 = require("../SceneManager");
var CameraUtility_1 = require("../CameraUtility");
var FrameTimer_1 = require("../FrameTimer");
var TextureCubeMap_1 = require("../TextureCubeMap");
var PipelineForwardZPrePass_1 = require("../pipeline/PipelineForwardZPrePass");
var Transform_1 = require("../Transform");
var SpriteRender_1 = require("../SpriteRender");
var Texture_1 = require("../Texture");
var Skybox_1 = require("../Skybox");
var GLUtility_1 = require("../gl/GLUtility");
var GLMath_1 = require("../math/GLMath");
var SampleGame = /** @class */ (function () {
    function SampleGame(canvas) {
        this.m_sceneInited = false;
        this.m_timer = new FrameTimer_1.FrameTimer(false);
        SampleGame.Instance = this;
        this.m_canvas = canvas;
        var pipe = new PipelineForwardZPrePass_1.PipelineForwardZPrePass();
        this.m_pipeline = pipe;
        var grender = new GraphicsRender_1.GraphicsRender(canvas, pipe);
        this.m_sceneMgr = new SceneManager_1.SceneManager();
        var sc = grender.shadowConfig;
        sc.shadowDistance = 20;
        this.m_graphicsRender = grender;
        Input_1.Input.init(canvas);
        this.createScene(grender.glctx);
        GLUtility_1.GLUtility.setTargetFPS(60);
        GLUtility_1.GLUtility.registerOnFrame(this.onFrame.bind(this));
        this.resizeCanvas();
        Utility_1.WindowUtility.setOnResizeFunc(this.resizeCanvas.bind(this));
    }
    SampleGame.prototype.resizeCanvas = function () {
        var canvas = this.m_canvas;
        this.m_graphicsRender.resizeCanvas(canvas.clientWidth, canvas.clientHeight);
    };
    SampleGame.prototype.onFrame = function (ts) {
        if (!this.m_sceneInited)
            return;
        var delta = this.m_timer.tick(ts);
        var dt = delta / 1000;
        Input_1.Input.onFrame(dt);
        var scene = this.m_scene;
        this.m_sceneMgr.onFrame(scene);
        var gredner = this.m_graphicsRender;
        gredner.render(scene, dt);
        gredner.renderToCanvas();
    };
    SampleGame.prototype.createScene = function (glctx) {
        return __awaiter(this, void 0, void 0, function () {
            var grender, tr, tex, skybox, cubepaths, texcube, tex360, scene, camera, spr, sprobj, srender, lightobj, light0;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        grender = this.m_graphicsRender;
                        tr = new Transform_1.Transform(null);
                        tr.forward = GLMath_1.vec3.down;
                        return [4 /*yield*/, glctx.createTextureImageAsync('res/images/tex0.png')];
                    case 1:
                        tex = _a.sent();
                        skybox = null;
                        cubepaths = [
                            "res/envmap/peak/peaks_ft.jpg",
                            "res/envmap/peak/peaks_bk.jpg",
                            "res/envmap/peak/peaks_up.jpg",
                            "res/envmap/peak/peaks_dn.jpg",
                            "res/envmap/peak/peaks_rt.jpg",
                            "res/envmap/peak/peaks_lf.jpg",
                        ];
                        return [4 /*yield*/, TextureCubeMap_1.TextureCubeMap.loadCubeMap(cubepaths, glctx)];
                    case 2:
                        texcube = _a.sent();
                        console.log(texcube);
                        return [4 /*yield*/, Texture_1.Texture.loadTexture2D('res/envmap/day360.jpg', glctx, false)];
                    case 3:
                        tex360 = _a.sent();
                        //skybox = Skybox.createFromTex360(tex360);
                        //skybox = Skybox.createFromCubeMap(texcube);
                        skybox = Skybox_1.Skybox.createFromProcedural();
                        scene = new Scene_1.Scene();
                        this.m_scene = scene;
                        camera = Camera_1.Camera.persepctive(null, 60, 400.0 / 300.0, 0.5, 1000);
                        camera.transform.setPosition(GLMath_1.glmath.vec3(0, 0, 5));
                        //camera.transform.setLookAt(glmath.vec3(0,0,0));
                        camera.transform.setLocalDirty();
                        camera.ambientColor = Utility_1.Utility.colorRGBA(3, 110, 167, 15);
                        camera.clearType = Camera_1.ClearType.Skybox;
                        camera.skybox = skybox;
                        camera.background = GLMath_1.glmath.vec4(0, 1, 0, 1);
                        camera.gameobject.addComponent(new CameraUtility_1.CameraFreeFly());
                        camera.gameobject.name = "camera";
                        camera.transform.parent = scene.transform;
                        this.m_camera = camera;
                        return [4 /*yield*/, Texture_1.Texture.loadTexture2D('res/images/img0.png', glctx, true)];
                    case 4:
                        spr = _a.sent();
                        sprobj = new GameObject_1.GameObject('sprite1');
                        srender = sprobj.addRender(SpriteRender_1.SpriteRender);
                        srender.image = spr;
                        srender.color.w = 0.5;
                        sprobj.transform.setPosition(GLMath_1.glmath.vec3(0, 1, -5));
                        sprobj.transform.parent = scene.transform;
                        console.log(sprobj.render.material.shaderTags);
                        lightobj = new GameObject_1.GameObject();
                        light0 = Light_1.Light.creatDirctionLight(lightobj, 1.0, GLMath_1.glmath.vec3(0.5, -1, 0.6));
                        light0.lightColor = new GLMath_1.vec3([1, 1, 1]);
                        lightobj.transform.parent = scene.transform;
                        this.m_sceneInited = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    SampleGame.cmdReload = function (target) {
        if (target != null)
            target.m_graphicsRender.reload();
    };
    SampleGame.cmdPassDebug = function () {
        var instance = SampleGame.Instance;
        if (instance != null)
            instance.m_pipeline.renderPassDebug = !instance.m_pipeline.renderPassDebug;
    };
    __decorate([
        DebugEntry_1.DebugEntry('cmd.reload')
    ], SampleGame, "cmdReload", null);
    __decorate([
        DebugEntry_1.DebugEntry('cmd.passDebug')
    ], SampleGame, "cmdPassDebug", null);
    return SampleGame;
}());
exports.SampleGame = SampleGame;
window['SampleGame'] = SampleGame;
